//
// Source: works.bas
// Translated from Basic to C++ using btran(~tm:)
// on Friday, November 17, 2000 at 15:48:53
//

#include <iostream.h>
#include <stdlib.h>
#include <unistd.h>
#include "basicfun.h"
#include "bstring.h"
#include "basicchannel.h"
#include "datalist.h"



//
// Function Prototypes
//
static double fntest1(double a, double b);

//
// Data Statement
//
static const char* DataValue[] = {
	"DATA STATEMENT",
	"10","1","9","3","8","5","7","7","6","9","5","11","4","13","3",
	"15","2","17","1","19","-1","-1", NULL};
DataListClass DataList(DataValue);

static double fntest1(double a, double b)
{
	double Result;

	Result = a + b;
	return Result;
}

int basic_main()
{
	BString a;
	Int32 a_V1;
	BString ch;
	Int32 ch_V2;
	Int32 crflag;
	double i;
	Int32 i_V4;
	Int32 j;
	Int32 sp;
	Int32 st;
	BString t;
	BString text;
	BString x;
	Int32 x_V5;
	BString x1;

	BStack(20);
	Int32 ch_V3[21];
	//
	// This is a test program to show a few of the things
	// that are actually working in the btran translator.
	//
	// It is not meant as a useful program, it just gives
	// a sample of some of the features that seem to work
	// completely, and to show that some fairly complex
	// programs can be compiled using this.
	//
	// I am leaving out things that don't work, because
	// this is a showcase of what does work, not what
	// doesn't work.
	// Uncomment this next line to use 32bit int's instead
	// of the default 16bit int's.
	BasicChannel[0] << "Test Program To Show ""Things That Really Work ""With My VaxBasic to C++ Converter" << endl;
	BasicChannel[0] << endl;
	BasicChannel[0] << "Enter a Number";
	BasicChannel[0] >> a_V1;
	BasicChannel[0] << "You Entered " << a_V1 << endl;
	BasicChannel[0] << endl;
	//
	// For loop on statement
	//
	BasicChannel[0] << "Implied FOR loop" << endl;
	for (i_V4 = 1; i_V4 <= 100; i_V4++)
	{
		BasicChannel[0] << i_V4 << '\t';
	}
	BasicChannel[0] << endl;
	BasicChannel[0] << endl;
	//
	// Let's calculate some primes (slowly)
	// I'm not using any fancy calculations, just a brute force
	// check to execerise the math sections.
	//
	BasicChannel[0] << "Prime Numbers" << endl;
	crflag = 0;
	// Loops don't work all the way to 32767% in 16bit mode,
	// because it increments to -32786 before the test
	for (i_V4 = 5; i_V4 <= a_V1; i_V4 += 2)
	{
		for (j = 3; j <= i_V4 / 2; j += 2)
		{
			if (((i_V4 / j) * j) == i_V4)
			{
				goto L_220;
			}
		}
		BasicChannel[0] << i_V4 << '\t';
		crflag = crflag + 1;
		if (crflag == 10)
		{
			BasicChannel[0] << endl;
			crflag = 0;
		}
L_220:;
	}
	BasicChannel[0] << endl;
	BasicChannel[0] << endl;
	//
	// Print a triangle (Play with some simple string functions)
	//
	BasicChannel[0] << "Triangle" << endl;
	for (i_V4 = 1; i_V4 <= 10; i_V4++)
	{
		for (j = 1; j <= 11 - i_V4; j++)
		{
			BasicChannel[0] << " ";
		}
		for (j = 1; j <= i_V4 * 2 - 1; j++)
		{
			BasicChannel[0] << "*";
		}
		BasicChannel[0] << endl;
	}
	//
	// And again using different functions to test string addition
	// (Warning: Negitive for loops need to see the unary minus
	// for btran to do the right thing)
	//
	for (i_V4 = 10; i_V4 >= 1; i_V4 -= 1)
	{
		text = "";
		for (j = 1; j <= 11 - i_V4; j++)
		{
			text = text + " ";
		}
		for (j = 1; j <= i_V4 * 2 - 1; j++)
		{
			text = text + "*";
		}
		BasicChannel[0] << text << endl;
	}
	//
	// And one more time for some string function tests
	// and an implied for loop
	//
	for (i_V4 = 1; i_V4 <= 10; i_V4++)
	{
		BasicChannel[0] << Qspace(11 - i_V4) << Qstring(i_V4 * 2 - 1, Ascii("*")) << endl;
	}
	//
	// Let's also try it with data statements
	//
	DataList.Read(t);
	BasicChannel[0] << t << endl;
	DataList.Read(sp);
	DataList.Read(st);
	while (sp != -1)
	{
		BasicChannel[0] << Qspace(sp) << Qstring(st, Ascii("*")) << endl;
		DataList.Read(sp);
		DataList.Read(st);
	}
	BasicChannel[0] << endl;
	//
	// Let's do a graph
	//
	BasicChannel[0] << "Sine Wave" << endl;
	for (i = -PI; i <= PI; i += 0.2)
	{
		x_V5 = sin(i) * 25 + 27;
		x = Qspace(26) + "|" + Qspace(26);
		x = left(x, x_V5 - 1) + "*" + right(x, x_V5 + 1);
		x_V5 = cos(i) * 25 + 27;
		x = left(x, x_V5 - 1) + "+" + right(x, x_V5 + 1);
		x1 = trm(x) + "";
		BasicChannel[0] << x1 << " " << Qnum1(strlen(x1)) << endl;
	}
	//
	// test gosub routines
	//
	x = "This is A";
	x1 = "Test Of Gosub";
	BGosub(L_1100);
	x = "Another";
	BGosub(L_1100);
	x1 = "Silly Test";
	BGosub(L_1100);
	goto L_2000;
L_1100:;
	BasicChannel[0] << x << " " << x1 << endl;
	BReturn;

	//
L_2000:;
	// Test simple DEF functions
	//
	BasicChannel[0] << endl;
	BasicChannel[0] << "Testing DEF Functions" << endl;
	BasicChannel[0] << "FNTEST1(1,2) = " << fntest1(1.0, 2.0) << endl;
	BasicChannel[0] << "FNTEST1(5,7) = " << fntest1(5.0, 7.0) << endl;
	BasicChannel[0] << "FNTEST1(7.5,6.2) = " << fntest1(7.5, 6.2) << endl;
	//
	// Test TAB
	//
	for (i_V4 = 1; i_V4 <= 10; i_V4++)
	{
;
		BasicChannel[0] << BasicChannel[0].Tab(i_V4);
;
		BasicChannel[0] << Ccpos(0) << endl;
	}
	for (i_V4 = 1; i_V4 <= 10; i_V4++)
	{
		BasicChannel[0] << "A";
		BasicChannel[0] << BasicChannel[0].Tab(i_V4) << "BB";
		BasicChannel[0] << BasicChannel[0].Tab(20) << "C" << endl;
	}
	//
	// Test CHANGE
	//
	BChange1("TEST STRING", ch_V2);
	BasicChannel[0] << endl;
	BasicChannel[0] << "CHANGE: ";
	for (i_V4 = 1; i_V4 <= ch_V3[0]; i_V4++)
	{
		BasicChannel[0] << ch_V3[i_V4];
	}
	BasicChannel[0] << endl;
	ch_V3[1] = 66;
	BChange2(ch_V2, ch);
	BasicChannel[0] << "CHANGE: " << ch << endl;
	//
	// Test INSTR
	//
	a = "1234567890";
	for (i_V4 = 0; i_V4 <= 9; i_V4++)
	{
		BasicChannel[0] << "INSTR TEST: " << i_V4 << '\t' << instr(1, a, Qnum1(i_V4)) << endl;
	}

	return EXIT_SUCCESS;
}
