//
// basic_main.cc
//
//	This function interfaces the C++ 'main' function to
//	the BASIC 'basic_main' function which is the starting
//	point of all translated basic programs.
//
//	This allows me to do various startup procedures that
//	need to be done to set up the translated enviornment.
//
// History
//
//	04/11/2000 - Kevin Handy
//		Modified to dump out an error message for any untrapped
//		BASIC errors that crash the program, instead of letting
//		it core dump.
//
#include <iostream.h>
#include <bstring.h>
#include <basicchannel.h>

//
// External declaration of the basic_main function that gets generated.
//
int basic_main();

//
// Global variables that need to be defined in one place
//
BChannel BasicChannel[MaxChannel + 1];

//
// Here is the main startup code
//
int main(int argc, char* argv[])
{
	//
	// Initialize channel zero as the console
	//
	BasicChannel[0].OpenZero();

	try
	{
		basic_main();
	}
	catch (BasicError error)
	{
		cerr << "BASIC Error: " << error.ErrorNo << " " <<
			ert(error.ErrorNo) << endl;
		return EXIT_FAILURE;
	}

	return EXIT_SUCCESS;
}
