/*******************************************************************************

Program:

	Varlist.h

Title:

	Header file for variable table

Description:

	This is the header file for the variable table/

Bugs:

	Lousy. Needs complete re-write

History:

	09/04/1998 - Kevin Handy
		Split out from variable.h

	12/05/1998 - Kevin Handy
		Added parameter to Lookup

	07/01/2000 - Kevin Handy
		Clean out commented out code.
		Lose ~VariableLise, which was empty.

*******************************************************************************/

//
// Variable.h - Some stuff just in case if isn't defined anywhere else
//
#ifndef _VARLIST_H_
#define _VARLIST_H_

//
// Include files
//
#include <iostream.h>
#include <string>
#include <map>
#include <vector>
#include "nodes.h"

#include "variable.h"

//
// Now, lets add some odds and ends to the List of Variables
//
class ListOfVariables:public map < string, VariableStruct, less<string> >
{
public:
	VariableStruct *LookupCpp(const string VarName);
	void Dump(void);
	void OutputDef(ostream& os, int Level);
};

//
// Class that holds a list of variables
//
class VariableList : public vector<ListOfVariables>
{
private:
	int vcount;			// Variable sequence counter

public:
	VariableList(void);

	void NewLevel();
	void KillLevel();
	void InitFunctions(void);
	void InitOneFunction(string BasName, char *CeeName, int Type,
		int Class=VARCLASS_FUNC);

	void Append(const VariableStruct& Variable, int GlobalFlag = FALSE);
	VariableStruct* Lookup(string VarName, const Node *ArrayRef,
		int ScanOneLevel = 0);
	VariableStruct* LookupCpp(const string VarName);
	int LookupReserved(const char *VarName);
	int LookupReserved(const string VarName);
	void Define(Node *ThisNode, int GlobalFlag = FALSE,
		int ThisOutput = FALSE);
	void Dump();
	void Fixup();
	void OutputDef(ostream& os, int Level)
	{ back().OutputDef(os, Level); }

private:
	void Fixup1(ListOfVariables* Variable);
};

#endif
